(define-module (ordo play)
  #:use-module (srfi srfi-26) ; cut
  #:use-module (ordo connection)
  #:use-module (ordo context)
  #:use-module (ordo task)
  #:export (play))

(define (play conn tasks)
  (call-with-connection
   conn
   (lambda (c)
     (let ((tmp-dir (car (connection-must c "mktemp" '("--directory"))))
           (ctx (make-context)))
       (set-context-scratch-dir! ctx tmp-dir)
       (dynamic-wind
         (const #t)
         (lambda () (for-each (cut run-task c ctx <>) tasks))
         (lambda () (connection-must c "rm" `("-rf" ,tmp-dir))))))))
