(define-module (ordo task)
  #:use-module (ice-9 match)
  #:use-module (srfi srfi-1) ; list utils
  #:use-module (srfi srfi-9) ; records
  #:use-module (srfi srfi-26) ; cut
  #:use-module (ordo context)
  #:export (task run-task))

(define-record-type <task>
  (make-task description action register triggers)
  task?
  (description get-description set-description!)
  (action get-action set-action!)
  (register get-register set-regiseter!)
  (triggers get-triggers set-triggers!))

(define* (task description action #:key register triggers)
  (make-task description action register triggers))

(define (run-task conn ctx task)
  (match task
    (($ <task> description action register triggers)
     (format #t "START ~a~%" description)
     (let ((result (action conn ctx)))
       (when register
         (register-context-var! ctx register result))
       (when triggers
         (add-context-triggers! ctx triggers))
       (format #t "END~%")))))
